// ===================== fonction utiles ==============================
// Fonctions utiles pour la vue de scenes 3D (surfaces triangulees)
// O.S. 2015
// TODO : debug TriaNormFast()
//=====================================================================
function [FaceLightIntensity]=Light(coord,itrnoe,LightDir) //,LightPos)
//==============================================================================
// Modele d'eclairage :
// Source de lumiere 
// Soleil => a l'infini (direction)
// Spot => (position,direction)
// Ponctuelle => (position)
// ***************************************************** TODO   *******************
FaceLightIntensity=[];
[nbp,trois]=size(coord);
if ( trois ~= 3 ) then
    printf("ERREUR les coordonnees doivent etre en 3D\n"); return;
end
[nbt,trois]=size(itrnoe);
// Normales aux faces
[Vnorm]=TriaNorm(coord,itrnoe);
//Vnorm=zeros(itrnoe);
//for i=1:nbt
//    NormT=normTri(coord(itrnoe(i,1),:),coord(itrnoe(i,2),:),coord(itrnoe(i,3),:));
//    Vnorm(i,:) = NormT;
//end
// Direction de l'eclairage
VNLight =LightDir/sqrt(sum(LightDir.*LightDir))
// Produit scalaire
FaceLightIntensity = zeros(nbt,1);
for i=1:nbt
    VNnorm_i = Vnorm(i,:)/sqrt(sum(Vnorm(i,:).*Vnorm(i,:)));    
    FaceLightIntensity(i)= sqrt(max(0.00001,sum(-VNLight .* VNnorm_i)));
end
endfunction


function [coord,itrnoe]=TriReadOFF(nomfich)
//=======================================================
// Lecture d'un fichier OFF
// renvoi la triangulation lue
coord=[];itrnoe=[];
fd=mopen(nomfich,'r');
nbp=0;nbt=0;
[nb,entete]=mfscanf(fd,"%s"); // nb= nombre d'enregistrements lus
if ( entete ~= "OFF" ) then 
    printf("ERREUR : un fichier OFF doit commencer par OFF en 1ere ligne\n");
    return; 
end
[nb,maxNbp,maxNbt,nba]=mfscanf(fd,"%f %f %f"); // nb= nombre d'enregistrements lus
coord=zeros(maxNbp,3);
itrnoe=zeros(maxNbt,3);
for nbp=1:maxNbp
    [nb,xi,yj,zk]=mfscanf(fd,"%f %f %f"); // nb= nombre d'enregistrements lus
     coord(nbp,1)=xi;coord(nbp,2)=yj;coord(nbp,3)=zk;   
end
for nbt=1:maxNbt
    [nb,nbpp,xi,yj,zk]=mfscanf(fd,"%f %f %f %f"); // nb= nombre d'enregistrements lus
    itrnoe(nbt,1)=xi;itrnoe(nbt,2)=yj;itrnoe(nbt,3)=zk;
end
mclose(fd);
itrnoe = itrnoe+1; // les indices commence a zero dans le fichier
endfunction

function TriWriteOFF(nomfich,coord,itrnoe)
//=======================================================
// Lecture d'un fichier OFF
// renvoi la triangulation lue
[nbpMax,trois]=size(coord);
[nbtMax,trois]=size(itrnoe);
fd=mopen(nomfich,'w');
nbp=0;nbt=0;
mfprintf(fd,"OFF\n"); // nb= nombre d'enregistrements lus
mfprintf(fd,"%d %d 0\n", int(nbpMax),int(nbtMax)); // nb= nombre d'enregistrements lus
for nbp=1:nbpMax
    xi=coord(nbp,1);yj=coord(nbp,2);zk=coord(nbp,3);   
    mfprintf(fd,"%f %f %f\n",xi,yj,zk); // nb= nombre d'enregistrements lus
end
itrnoe = itrnoe-1; // les indices commence a zero dans le fichier
for nbt=1:nbtMax
    n1=itrnoe(nbt,1);n2=itrnoe(nbt,2);n3=itrnoe(nbt,3);
    mfprintf(fd,"3 %d %d %d\n",n1,n2,n3); // nb= nombre d'enregistrements lus
end
mclose(fd);
endfunction


function CenterT= CentreTri(P1,P2,P3)
//=======================================================
CenterT = P1 + P2 + P3;
endfunction


function NormT=normTri(P1,P2,P3)
//=======================================================
// 
u = P2 - P1;
v = P3 - P2;
NormT = cross(u,v)
//NormT = CrossProd(u,v)
endfunction

function [NormT]=TriaNorm(XYZcoord,itrnoe)
//==============================================================================
// Version standard
[nbt,trois]=size(itrnoe)
V=zeros(nbt,3)
U=zeros(nbt,3)
for i=1:nbt
j=1;
U(i,:) = XYZcoord(itrnoe(i,j),:) - XYZcoord(itrnoe(i,j+1),:);
j=j+1;
V(i,:) = XYZcoord(itrnoe(i,j),:) - XYZcoord(itrnoe(i,j+1),:);
end
//
NormT=cross(U',V')';
endfunction

function [NormT]=TriaNormFast(XYcoord,itrnoe)
//==============================================================================
// Version vectorielle !!! A REVOIR !!! BUG
// AireT(i) : aire du triangle "i"
// En 3D on peut renvoyer la normale : TODO !!!
AireT=[];
XP1 = XYcoord(itrnoe(:,1),1); YP1 = XYcoord(itrnoe(:,1),2); 
ZP1 = XYcoord(itrnoe(:,1),3); // ZP1=zeros(XP1)';
XP2 = XYcoord(itrnoe(:,2),1); YP2 = XYcoord(itrnoe(:,2),2);
ZP2 = XYcoord(itrnoe(:,2),3); // ZP2=zeros(XP1)';
XP3 = XYcoord(itrnoe(:,3),1); YP3 = XYcoord(itrnoe(:,3),2);
ZP3 = XYcoord(itrnoe(:,3),3); // ZP3=zeros(XP1)';
XV1 = XP2 - XP1;  YV1 = YP2 - YP1; ZV1 = ZP2 - ZP1;
XV2 = XP3 - XP2;  YV2 = YP3 - YP2; ZV1 = ZP2 - ZP1;
//XV3 = XP1 - XP3;  YV3 = YP1 - YP3; ZV1 = ZP2 - ZP1;

V1= [XV1,YV1,ZP1]'
V2= [XV2,YV2,ZP2]'
W = cross(V1,V2)
//AireT=0.5* W(3,:)' // on met en colonne
NormT=W'; // pas normalise !
endfunction


function [p] = CrossProd(u,v)
//Calculates the cross-product of two vectors u and v.
//Vectors u and v can be columns or row vectors, but
//they must have only three elements each.
[nu,mu] = size(u);
[nv,mv] = size(v);
if nu*mu <> 3 | nv*mv <> 3 then
error('Vectors must be three-dimensional only')
abort;
end
A1 = [ u(2), u(3); v(2), v(3)];
A2 = [ u(3), u(1); v(3), v(1)];
A3 = [ u(1), u(2); v(1), v(2)];
px = det(A1); py = det(A2); pz = det(A3);
p = [px, py, pz]
endfunction

function [itaf]=BackFaceCulling(coordH,itrnoe,PCamera)
//==============================================================
// Vue perspective : VectVue est = CentreTriangle - PCamera 
// PCamera est la position de la camera
// Vue orthographique : VectVue est = (0,0,-1)
// TODO : vectoriser tout ca !!!
//
j=0; nbt = length(itrnoe(:,1))
itaf=[];
Vnorm=zeros(itrnoe);
for i=1:nbt
    P1 = coordH(itrnoe(i,1),1:3);
    P2 = coordH(itrnoe(i,2),1:3);
    P3 = coordH(itrnoe(i,3),1:3);
    NormT=normTri(P1,P2,P3);     CentreT=(P1+P2+P3)/3.0;
    Vnorm(i,:) = NormT;
    VectVue = CentreT - PCamera ; // Perspective
    if ( (NormT * VectVue') < 0) then
//        printf("face %d vue\n",i)
        j=j+1; itaf(j)=i;
    end
end
endfunction


function []= TriPlot2d(coord2D,itrnoe,couleur)
//=====================================================
// Affichage de la triangulation 2D
[m,n]=size(itrnoe);
if (argn(2) < 3) then
    couleur=[];
    else
if (length(couleur) == 1 ) then
    couleur=zeros(m,1)+couleur; 
end
end
XmM=1.1*[min(coord2D(:,1)),max(coord2D(:,1))]
YmM=1.1*[min(coord2D(:,2)),max(coord2D(:,2))]
rectm=[XmM;YmM]
// Affichage de 2 points extremes et creation de la vue
plot2d(-rectm(1,1),-rectm(2,1),style=0,rect=rectm,frameflag=3);
//
xpols=matrix(coord2D(itrnoe,1),m,n);
ypols=matrix(coord2D(itrnoe,2),m,n);
if ( isempty(couleur)) then
xpolys(xpols',ypols'); // pour tracer des polygones !! ATTENTION IL FAUT FERMER !!
else
xfpolys(xpols',ypols',couleur); // pour tracer des polygones
end
endfunction


//function [MXYZ]=applyMatPL(M,XYZ)
function [MXYZ]=ApplyTransform(M,XYZ)
//=================================================
// XYZ est donne en ligne : x1, y1...; x2, y2...; ...
nbp = length(XYZ(:,1));
MXYZ=zeros(XYZ)';
for i=1: nbp
    MXYZ(:,i) = M * XYZ(i,:)'
end
MXYZ=MXYZ';
endfunction

function [MXYZ]=applyMatPC(M,XYZ)
//=================================================
// XYZ est donne en colonne : x1, x2, x3...; y1, y2, y3 ...
nbp = length(XYZ(1,:));
MXYZ=zeros(XYZ);
for i=1: nbp
    MXYZ(:,i) = M * XYZ(:,i)
end
endfunction

//function [XYZCamera]=HomoToCamera(coordH, perspective)
function [XYZCamera]=PlanImage(perspective,coordH)
//=================================================
// Projection des points "coordH" sur le PLAN image : Z = distance focale
// image du point i
// ? faut-il ajouter le clipping en Z ????
//
nbp = length(coordH(:,1))
XYZCamera=zeros(nbp,3);
for i=1: nbp
coordHCamera = perspective * coordH(i,:)'
//if ( coordHCamera(4) <= 0 ) then   des points DERRIERE LA CAMERA !!!!
if ( coordHCamera(4) == 0 ) then
    printf("ERREUR : le point %d est sur le plan image de la camera\n",int(i)); 
    XYZCamera=[];
    return;
end
XYZCamera(i,1) = coordHCamera(1)./coordHCamera(4)
XYZCamera(i,2) = coordHCamera(2)./coordHCamera(4)
XYZCamera(i,3) = coordHCamera(3)./coordHCamera(4)
// Afficher les sommets seulement
//plot2d(XYZCamera(:,1),XYZCamera(:,2), style=-3)
end
endfunction

function [coord,itrnoe]=TriBox(Xlarg,Zlong,Yhaut)
// =========================================================================
// triangulation representant la surface d'une boite
a=Xlarg/2.0; b=Yhaut/2.0; c=Zlong/2.0
coord = [-a,-b,c; a,-b,c; a,b,c; -a,b,c; -a,-b,-c; a,-b,-c; a,b,-c; -a,b,-c];
n=4;
itrnoe = [1,2,3;      1,3,4; ...
        2,n+2, n+3;   n+3,3,2; ...
        3,n+3, n+4;   n+4,4,3; ...
        
        4,n+4, n+1;   n+1,1,4; ...
        1,n+1, n+2;   n+2,2,1; ...
        1+n,3+n,2+n;  1+n,4+n,3+n]; 
endfunction

