// -----------------------------------------------------------------------------
// TP visualisation des Triangulations (3D) sous Scilab
// OS - 09-2018
// Dans ce TP  vous manipulerez  des surfaces triangulees afin de les  afficher
// avec un modele d'eclairage simple (EXTENSION). Pour resoudre le probleme des 
// parties cachees vous appliquerez le principe de l'algorithme du peintre
//   
// Des fonctions ont deja ete programmees afin de faciliter le TP
// exec("FonctionsUtiles.sci",-1)
//
// TriPlot2d(coord2D,triangles,couleur); affiche des triangles 2D dans la vue 
//    courante.
// [coord,itrnoe]=TriReadOFF(nomfich); lecture d'une triangulation dans un 
//    fichier ascii.
// 
// -----------------------------------------------------------------------------
exec("FonctionsUtiles.sci",-1)
// -----------------------------------------------------------------------------
// Etape 1 : Affichage et manipulation elementaires d'une triangulation - 15 min
// -----------------------------------------------------------------------------
// Affichage d'un rectangle compose de 2 triangles
// 0.1 Definition de la triangulation
a=3; b=5; // a = 1/2 largeur, b = 1/2 hauteur
XYcoord = [-a,-b; a,-b; a,b; -a,b] // coordonnees des points
itrnoe = [1,2,3; 1,3,4] // definition des triangles : les numeros donnent 
[nbpoints,dim]= size(XYcoord)
// l'indice des coordonnees des sommets dans le tableau "coord"
// pour s'en convaincre :
it=1; // le numero du triangle
XY_it=XYcoord(itrnoe(it,:),:) // les coordonnees du triangle "it"

couleur=color("green")
// couleur est un code, vous pouvez visualiser les couleurs et les codes 
// correspondant de la palette courante (colormap)avec la commande : getcolor()
// Pour afficher la triangulation (definie dans "FonctionsUtiles.sci"):
TriPlot2d(XYcoord,itrnoe,couleur); 
// Mais on peut aussi fixer la couleur de chaque triangle
TriPlot2d(XYcoord,itrnoe,[2,5])


// 1.1. Corriger les erreurs dans la ligne suivante pour afficher le premier 
//      sommet du triangle it
plot2d(XYcoord(itrnoe(it,1)),XYcoord(itrnoe(it,2)),style=-3)
// En effet, le point qui est affiche ne correspond pas au point numero 1 de 
// coordonnees (-3,-5)
// Identifiez l'erreur qui a ete commise.
// Expliquez le resultat qui est affiche et pourquoi :
// 1.2. Sur le meme exemple affichez le troisieme sommet du deuxieme triangle

// ----------------------------------------------------------------------------
// Etape 2 : Manipulation des triangulations -                            30 min
// ----------------------------------------------------------------------------
// 2.1. Que fait la ligne ci-dessous ? 
//    Affichez la nouvelle triangulation. 
//    Quelle difference avec la triangulation precedente (et a l'affichage) ?
XYZcoord = [XYcoord, zeros(nbpoints,1)]

// 2.2. Verifier l'orientation des faces : calculer la normale et verifier.
//    Pour le produit vectoriel on utilisera : "cross(u,v)".
//    Verifier que l'aire totale du rectangle est correcte.
//    
// 2.3 Ecrire le calcul des normales sous la forme d'une fonction :
//    function [N]=Normales(XYZcoord,itrnoe) ...
//    N(i,:) contiendra la normale du triangle i
function [N]=Normales(XYZcoord,itrnoe)
    //...
endfunction

// 2.4. Appliquer une translation du rectangle de dX=-5
//    Verifier que l'aire du rectangle projete n'a pas change

// 2.5. Appliquer une rotation d'axe Z et d'angle 45° aux points de la triangu-
// lation en vous inspirant de la ligne suivante ?
      [[2,0,0;0,2,0;0,0,2] * [1,2,3]']'
//    Verifier que l'aire du rectangle projete n'a pas change
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// 3. Le "back-face culling"                                        10 (+15) min
// Le "BackFaceCulling" supprime les faces qui ne sont pas vus (et donc pas a
// affichees). 
//
// 3.1. Charger la triangulation "triangulation_2.off" et afficher le resultat
//    On supposera que les faces sont correctement orientees vers l'exterieur.
//    Combien de triangles, combien de sommets contient-elle ?
//
// 3.2. Filtrer les triangles dont la normale indique qu'ils ne sont pas vus.
//    Afficher seulement les triangles vus ("back-face culling")

// 3.3. Analyse des normales (extension): 
//    On considere que la triangulation donnee correspond au maillage de la 
//    frontiere d'une boite (6 faces). Les normales aux triangles d'une meme face 
//    devraient etre egales. Verifiez que ce n'est pas le cas ! 
//    Combien de vecteurs differents ? vous utiliserez "unique(N,"r")" pour les 
//    compter. Expliquer le resultat. En guise d'indice : evaluer le resultat
//    de la commande : cos(%pi/2)... Conclure.
//
// -----------------------------------------------------------------------------
// 3.1. 
nomfich="data/triangulation_2.off" // 
[XYZcoord,itrnoe]=TriReadOFF(nomfich);
[nbt,trois]=size(itrnoe);
TriPlot2d(XYZcoord,itrnoe)

// 3.2. Afficher seulement les triangles vus
trianglesvus = //... a completer ...
TriPlot2d(XYZcoord,itrnoe(trianglesvus,:),3)

// 3.3. Analyse des normales (facultatif): 

// -----------------------------------------------------------------------------
// 4. L'algorithme du peintre                                             15 min
// Dans le cas d'une scene non triviale il est necessaire de traiter le probleme 
// des parties cachees. L'approche la plus simple consiste a trier les faces et
// a les afficher de la plus eloignee a la plus proche (de l'observateur=camera)
//
// 4.1. Constater le probleme en appliquant le back-face culling sur 
//   "triangulation_3.off"
// 4.2. Utiliser la fonction "gsort" pour realiser le tri. Vous utiliserez la 
//    position des centres des triangles.
//    La fonction TriPlot2d affiche les triangles dans l'ordre du tableau :-)
//
// -----------------------------------------------------------------------------
nomfich="data/triangulation_3.off" // 
[XYZcoord,itrnoe]=TriReadOFF(nomfich);
[nbt,trois]=size(itrnoe);
TriPlot2d(XYZcoord,itrnoe)
//...

// ---------------------------- EXTENSION --------------------------------------
// 5. Eclairage : reflexion diffuse                                       30 min
// Le 3ieme parametre de TriPlot2d donne la couleur d'affichage des faces
// Nous allons utiliser cette possibilite pour "simuler" un eclairage en 64
// niveaux de gris. Il faut d'abord charger la palette (en niveau de gris) dans 
// la figure adhoc :
ifig=500;
nbcolor=64;
ifig=ifig+1;scf(ifig);
h=scf(ifig);h.color_map = graycolormap(nbcolor);
// getcolor permet de voir les "couleurs" correspondant a chaque numero (code))
getcolor()
// Ensuite il faudra affecter les couleurs de 1 a 64 en fonction de l'eclairage
// La fonction "Light()" renvoi l'intensite de reflexion diffuse de chaque face 
// (Loi de Lambert). pour une source directionnelle (Soleil par exemple).
// 5.1. Fixer l'eclairage de face (le soleil est sur la camera)
// 5.2. Transformer cette intensite en numero de couleur (dans la palette)
// Et afficher le resultat
// 5.3. Deplacer l'eclairage face a l'elephant et afficher le resultat
// -----------------------------------------------------------------------------
// 5.1. Fixer l'eclairage de face (le soleil est sur la camera)
LightDir=[]; // A remplir
[FaceLightIntensity]=Light(XYZcoord,itrnoe,LightDir); // 
//...

// 5.2. Transformer cette intensite en numero de couleur (dans la palette)
// Et afficher le resultat


// 5.3. Deplacer l'eclairage face a l'elephant et afficher le resultat



