# -*- coding: utf-8 -*-
"""
Created on Wed Oct  9 14:52:14 2019

// TP visualisation des Triangulations (3D) sous Python
// OS - 10-2019
// Dans ce TP  vous manipulerez  des surfaces triangulees afin de les  afficher
// avec un modele d'eclairage simple (EXTENSION). Pour resoudre le probleme des 
// parties cachees vous appliquerez le principe de l'algorithme du peintre
//   
// Des fonctions ont deja ete programmees afin de faciliter le TP :
// import FonctionsUtiles as FU
//
// TriPlot2d(XYZcoord2D,triangles) affiche des triangles 2D dans la vue 
//    courante.
// [XYZcoord,itrnoe]=TriReadOFF(nomfich) lecture d'une triangulation dans un 
//    fichier ascii.
// 

@author: ostab
"""

import matplotlib.pyplot as plt
import numpy as np
import matplotlib.colors

import FonctionsUtiles as FU
# -----------------------------------------------------------------------------
# Etape 1 : Affichage et manipulation elementaires d'une triangulation - 15 min
# -----------------------------------------------------------------------------
# Affichage d'un rectangle compose de 2 triangles
# 0.1 Definition de la triangulation
a=3; b=5; # a = 1/2 largeur, b = 1/2 hauteur
XYcoord = np.asarray([ [-a,-b], [a,-b], [a,b], [-a,b] ]) # coordonnees des points
itrnoe = np.asarray([ [0,1,2], [0,2,3]]) # definition des triangles : les numeros donnent 
nbpoints= len(XYcoord)
nbtriangles= len(itrnoe)

# l'indice des coordonnees des sommets dans le tableau "coord"
# pour s'en convaincre :
it=0 # le numero du triangle
XY_it= XYcoord[ itrnoe[it,:],:] # les coordonnees du triangle "it"

# Pour afficher la triangulation :
triangleColor = np.ones(nbtriangles)
plt.tripcolor(XYcoord[:,0],XYcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2)
plt.show()
# Mais on peut aussi fixer la couleur de chaque triangle
triangleColor = [1,2]
plt.tripcolor(XYcoord[:,0],XYcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2)
plt.show()
# et pour afficher les points :
plt.tripcolor(XYcoord[:,0],XYcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2)
p = plt.plot(XYcoord[:,0],XYcoord[:,1], 'ro') # go pour green, r+ pour red cross
plt.show()


# 1.1. Corriger les erreurs dans la ligne suivante pour afficher le premier 
#      sommet du triangle it
plt.tripcolor(XYcoord[:,0],XYcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2)
it = 0
p = plt.plot(XYcoord[itrnoe[it,0],0],XYcoord[[itrnoe[it,1]],0], 'ro') # go pour green, r+ pour red cross
plt.show()
# ...

# 1.2. Sur le meme exemple affichez le troisieme sommet du deuxieme triangle


# ----------------------------------------------------------------------------
# Etape 2 : Manipulation des triangulations -                            30 min
# ----------------------------------------------------------------------------
# 2.1. Que fait la ligne ci-dessous ? 
#    Affichez la nouvelle triangulation. 
#    Quelle difference avec la triangulation precedente (et a l'affichage) ?
XYZcoord = np.asarray([XYcoord[:,0], XYcoord[:,1], np.zeros(len(XYcoord[:,0]))]) 
XYZcoord = np.asarray(XYZcoord.T)
# 2.2. Verifier l'orientation des faces : calculer la normale et verifier.
#    Pour le produit vectoriel on utilisera : "np.cross(u,v)".
#    Verifier que l'aire totale du rectangle est correcte.
#    
# 2.3 Ecrire le calcul des normales sous la forme d'une fonction :
#    def Normales(XYZcoord,itrnoe): ...
#    N[i,:] contiendra la normale du triangle i
def Normales(XYZcoord,itrnoe):
    #...
    return N

# 2.4. Appliquer une translation du rectangle de dX=-5
#    Verifier que l'aire du rectangle projete n'a pas change

# 2.5. Appliquer une rotation d'axe Z et d'angle 45° aux points de la triangu-
# lation en vous inspirant des lignes suivantes ?
M = np.asarray([[2,0,0],[0,2,0],[0,0,2]])
A = np.asarray([1,2,3])
M.dot(A.T).T

#    Verifier que l'aire du rectangle projete n'a pas change



# -----------------------------------------------------------------------------
# 3. Le "back-face culling"                                        10 (+15) min
# Le "BackFaceCulling" supprime les faces qui ne sont pas vus (et donc pas a
# affichees). 
#
# 3.1. Charger la triangulation "triangulation_2.off" et afficher le resultat
#    On supposera que les faces sont correctement orientees vers l'exterieur.
#    Combien de triangles, combien de sommets contient-elle ?

# 3.2. Filtrer les triangles dont la normale indique qu'ils ne sont pas vus.
#    Afficher seulement les triangles vus ("back-face culling")

# 3.3. Analyse des normales (extension): 
#    On considere que la triangulation donnee correspond au maillage de la 
#    frontiere d'une boite (6 faces). Les normales aux triangles d'une meme face 
#    devraient etre egales. Verifiez que ce n'est pas le cas ! 
#    Combien de vecteurs differents ? vous utiliserez "unique(N,"r")" pour les 
#    compter. Expliquer le resultat. En guise d'indice : evaluer le resultat
#    de la commande : cos(%pi/2)... Conclure.
#
# -----------------------------------------------------------------------------
# 3.1.       
nomfich="data/triangulation_2.off" 
[XYZcoord,itrnoe]=FU.TriReadOFF(nomfich) 
nbpoints= len(XYZcoord)
nbtriangles= len(itrnoe)
FU.TriPlot2d(XYZcoord,itrnoe)

# 3.2. Afficher seulement les triangles vus
trianglesvus = [0,1] #... a completer ...
trianglesvus = [0] #... a completer ...

FU.TriPlot2d(XYZcoord,itrnoe[trianglesvus,:])

# 3.3. Analyse des normales (facultatif): 

# -----------------------------------------------------------------------------
# 4. L'algorithme du peintre                                             15 min
# Dans le cas d'une scene non triviale il est necessaire de traiter le probleme 
# des parties cachees. L'approche la plus simple consiste a trier les faces et
# a les afficher de la plus eloignee a la plus proche (de l'observateur=camera)
#
# 4.1. Constater le probleme en appliquant le back-face culling sur 
#   "triangulation_3.off"
# 4.2. Utiliser la fonction np.argsort() pour realiser le tri.Vous utiliserez la 
#    position des centres des triangles.
#    La fonction TriPlot2d affiche les triangles dans l'ordre du tableau :-)
#
# -----------------------------------------------------------------------------
nomfich="data/triangulation_3.off" 
[XYZcoord,itrnoe]=FU.TriReadOFF(nomfich)
nbpoints= len(XYZcoord)
nbtriangles= len(itrnoe)
FU.TriPlot2d(XYZcoord,itrnoe)
#...

# ---------------------------- EXTENSION --------------------------------------
# 5. Eclairage : reflexion diffuse                                       30 min
# Le 4ieme parametre de tripcolor donne la couleur d'affichage des faces
# Nous allons utiliser cette possibilite pour "simuler" un eclairage en 
# niveaux de gris : donnes dans "TrianglesGreyIntensity"
import matplotlib.colors


# tripcolor peut prendre une palette particuliere :
cmap = matplotlib.colors.ListedColormap("limegreen")
# cmap est une palette de couleur ici reduite a une couleur unique 
cmap = matplotlib.colors.ListedColormap("default")

# Attention, les numeros dans "triangleColor" ne donnent pas la couleur, 
# c'est [min(triangleColor), max(triangleColor)] qui est associe aux n couleurs 
# de la palette : [couleur_0,...,couleur_n]

triangleColor = list(range(0, len(itrnoe)))
triangleColor = np.ones(len(itrnoe))
triangleColor = np.arange(len(itrnoe))
plt.tripcolor(XYZcoord[:,0],XYZcoord[:,1],itrnoe, triangleColor, edgecolor="k", lw=2, shading='flat', cmap=cmap)
plt.colorbar()
plt.show()


TrianglesGreyIntensity = ...
plt.tripcolor(xy[:,0],xy[:,1],triangles, TrianglesGreyIntensity,shading='flat', cmap=plt.cm.get_cmap("Greys"))
plt.show()


TrianglesGreyIntensity = ...
plt.tripcolor(xy[:,0],xy[:,1],triangles, TrianglesGreyIntensity,shading='gouraud', cmap=plt.cm.get_cmap("Greys"))
plt.show()


# Ensuite il faudra affecter les couleurs en fonction de l'eclairage. Ecrire la
# fonction "Light()" qui renvoi l'intensite de reflexion diffuse de chaque face 
# (Loi de Lambert). pour une source directionnelle (Soleil par exemple).
# 5.1. Fixer l'eclairage de face (le soleil est sur la camera)
# 5.2. Transformer cette intensite en numero de couleur (dans la palette)
# Et afficher le resultat
# 5.3. Deplacer l'eclairage face a l'elephant et afficher le resultat
# -----------------------------------------------------------------------------
# 5.1. Fixer l'eclairage de face (le soleil est sur la camera)

# 5.2. Transformer cette intensite en numero de couleur (dans la palette)
# Et afficher le resultat

# 5.3. Deplacer l'eclairage face a l'elephant et afficher le resultat


